diff -urN ../VisualBoyAdvance-1.7.2/src/win32/DirectSound.cpp ./src/win32/DirectSound.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/DirectSound.cpp	2004-05-13 23:27:55 +0900
+++ ./src/win32/DirectSound.cpp	2006-08-26 01:11:43 +0900
@@ -1,6 +1,7 @@
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
 // Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2004-2006 VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -16,358 +17,357 @@
 // along with this program; if not, write to the Free Software Foundation,
 // Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 
+// MFC
 #include "stdafx.h"
-#include "VBA.h"
+
+// Tools
 #include "AVIWrite.h"
-#include "Sound.h"
 #include "WavWriter.h"
 
+// Internals
 #include "../System.h"
 #include "../GBA.h"
 #include "../Globals.h"
 #include "../Sound.h"
 
-#include <mmreg.h>
-#include <dsound.h>
+// DirectSound8
+#include <Dsound.h>
+#pragma comment( lib, "Dsound" )
+#pragma comment( lib, "Dxguid" )
+
 
 class DirectSound : public ISound
 {
 private:
-  HINSTANCE            dsoundDLL;
-  LPDIRECTSOUND        pDirectSound;
-  LPDIRECTSOUNDBUFFER  dsbPrimary;
-  LPDIRECTSOUNDBUFFER  dsbSecondary;
-  LPDIRECTSOUNDNOTIFY  dsbNotify;
-  HANDLE               dsbEvent;
-  WAVEFORMATEX         wfx;
+	LPDIRECTSOUND8       pDirectSound; // DirectSound interface
+	LPDIRECTSOUNDBUFFER  dsbPrimary;   // Primary DirectSound buffer
+	LPDIRECTSOUNDBUFFER  dsbSecondary; // Secondary DirectSound buffer
+	LPDIRECTSOUNDNOTIFY8 dsbNotify;
+	HANDLE               dsbEvent;
+	WAVEFORMATEX         wfx;          // Primary buffer wave format
 
 public:
-  DirectSound();
-  virtual ~DirectSound();
+	DirectSound();
+	virtual ~DirectSound();
 
-  bool init();
-  void pause();
-  void reset();
-  void resume();
-  void write();
+	bool init();   // initialize the primary and secondary sound buffer
+	void pause();  // pause the secondary sound buffer
+	void reset();  // stop and reset the secondary sound buffer
+	void resume(); // resume the secondary sound buffer
+	void write();  // write the emulated sound to the secondary sound buffer
 };
 
+
 DirectSound::DirectSound()
 {
-  dsoundDLL    = NULL;
-  pDirectSound = NULL;
-  dsbPrimary   = NULL;
-  dsbSecondary = NULL;
-  dsbNotify    = NULL;
-  dsbEvent     = NULL;
+	CoInitialize( NULL );
+	
+	pDirectSound  = NULL;
+	dsbPrimary    = NULL;
+	dsbSecondary  = NULL;
+	dsbNotify     = NULL;
+	dsbEvent      = NULL;
 }
 
+
 DirectSound::~DirectSound()
 {
-  if(theApp.aviRecorder != NULL) {
-    delete theApp.aviRecorder;
-    theApp.aviRecorder = NULL;
-    theApp.aviFrameNumber = 0;
-  }
-
-  if(theApp.soundRecording) {
-    if(theApp.soundRecorder != NULL) {
-      delete theApp.soundRecorder;
-      theApp.soundRecorder = NULL;
-    }
-    theApp.soundRecording = false;
-  }
-  
-  if(dsbNotify != NULL) {
-    dsbNotify->Release();
-    dsbNotify = NULL;
-  }
-
-  if(dsbEvent != NULL) {
-    CloseHandle(dsbEvent);
-    dsbEvent = NULL;
-  }
-  
-  if(pDirectSound != NULL) {
-    if(dsbPrimary != NULL) {
-      dsbPrimary->Release();
-      dsbPrimary = NULL;
-    }
-    
-    if(dsbSecondary != NULL) {
-      dsbSecondary->Release();
-      dsbSecondary = NULL;
-    }
-    
-    pDirectSound->Release();
-    pDirectSound = NULL;
-  }
-  
-  if(dsoundDLL != NULL) {
-    FreeLibrary(dsoundDLL);
-    dsoundDLL = NULL;
-  }
+	if(theApp.aviRecorder) {
+		delete theApp.aviRecorder;
+		theApp.aviRecorder = NULL;
+		theApp.aviFrameNumber = 0;
+	}
+	
+	if(theApp.soundRecording) {
+		if(theApp.soundRecorder) {
+			delete theApp.soundRecorder;
+			theApp.soundRecorder = NULL;
+		}
+		theApp.soundRecording = false;
+	}
+	
+	if(dsbNotify) {
+		dsbNotify->Release();
+		dsbNotify = NULL;
+	}
+	
+	if(dsbEvent) {
+		CloseHandle(dsbEvent);
+		dsbEvent = NULL;
+	}
+	
+	if(pDirectSound) {
+		if(dsbPrimary) {
+			dsbPrimary->Release();
+			dsbPrimary = NULL;
+		}
+
+		if(dsbSecondary) {
+			dsbSecondary->Release();
+			dsbSecondary = NULL;
+		}
+		
+		pDirectSound->Release();
+		pDirectSound = NULL;
+	}
+	
+	CoUninitialize();
 }
 
+
 bool DirectSound::init()
 {
-  HRESULT hr;
-
-  dsoundDLL = LoadLibrary("DSOUND.DLL");
-  HRESULT (WINAPI *DSoundCreate)(LPCGUID,LPDIRECTSOUND *,IUnknown *);  
-  if(dsoundDLL != NULL) {    
-    DSoundCreate = (HRESULT (WINAPI *)(LPCGUID,LPDIRECTSOUND *,IUnknown *))
-      GetProcAddress(dsoundDLL, "DirectSoundCreate");
-    
-    if(DSoundCreate == NULL) {
-      theApp.directXMessage("DirectSoundCreate");
-      return false;
-    }
-  } else {
-    theApp.directXMessage("DSOUND.DLL");
-    return false;
-  }
-  
-  if((hr = DSoundCreate(NULL,&pDirectSound,NULL) != DS_OK)) {
-    //    errorMessage(myLoadString(IDS_ERROR_SOUND_CREATE), hr);
-    systemMessage(IDS_CANNOT_CREATE_DIRECTSOUND,
-                  "Cannot create DirectSound %08x", hr);
-    pDirectSound = NULL;
-    dsbSecondary = NULL;
-    return false;
-  }
-
-  if((hr=pDirectSound->SetCooperativeLevel((HWND)*theApp.m_pMainWnd,
-                                           DSSCL_EXCLUSIVE)) != DS_OK) {
-    //    errorMessage(myLoadString(IDS_ERROR_SOUND_LEVEL), hr);
-    systemMessage(IDS_CANNOT_SETCOOPERATIVELEVEL,
-                  "Cannot SetCooperativeLevel %08x", hr);
-    return false;
-  }
-
-  DSBUFFERDESC dsbdesc;
-  ZeroMemory(&dsbdesc,sizeof(DSBUFFERDESC));
-  dsbdesc.dwSize=sizeof(DSBUFFERDESC);
-  dsbdesc.dwFlags = DSBCAPS_PRIMARYBUFFER;
-  
-  if((hr=pDirectSound->CreateSoundBuffer(&dsbdesc,
-                                         &dsbPrimary,
-                                         NULL) != DS_OK)) {
-    //    errorMessage(myLoadString(IDS_ERROR_SOUND_BUFFER),hr);
-    systemMessage(IDS_CANNOT_CREATESOUNDBUFFER,
-                  "Cannot CreateSoundBuffer %08x", hr);
-    return false;
-  }
-  
-  // Set primary buffer format
-
-  memset(&wfx, 0, sizeof(WAVEFORMATEX)); 
-  wfx.wFormatTag = WAVE_FORMAT_PCM; 
-  wfx.nChannels = 2;
-  switch(soundQuality) {
-  case 2:
-    wfx.nSamplesPerSec = 22050;
-    soundBufferLen = 736*2;
-    soundBufferTotalLen = 7360*2;
-    break;
-  case 4:
-    wfx.nSamplesPerSec = 11025;
-    soundBufferLen = 368*2;
-    soundBufferTotalLen = 3680*2;
-    break;
-  default:
-    soundQuality = 1;
-    wfx.nSamplesPerSec = 44100;
-    soundBufferLen = 1470*2;
-    soundBufferTotalLen = 14700*2;
-  }
-  wfx.wBitsPerSample = 16; 
-  wfx.nBlockAlign = (wfx.wBitsPerSample / 8) * wfx.nChannels;
-  wfx.nAvgBytesPerSec = wfx.nSamplesPerSec * wfx.nBlockAlign;
-
-  if((hr = dsbPrimary->SetFormat(&wfx)) != DS_OK) {
-    //    errorMessage(myLoadString(IDS_ERROR_SOUND_PRIMARY),hr);
-    systemMessage(IDS_CANNOT_SETFORMAT_PRIMARY,
-                  "Cannot SetFormat for primary %08x", hr);
-    return false;
-  }
-  
-  ZeroMemory(&dsbdesc,sizeof(DSBUFFERDESC));  
-  dsbdesc.dwSize = sizeof(DSBUFFERDESC);
-  dsbdesc.dwFlags = DSBCAPS_GETCURRENTPOSITION2|DSBCAPS_CTRLPOSITIONNOTIFY;
-  dsbdesc.dwBufferBytes = soundBufferTotalLen;
-  dsbdesc.lpwfxFormat = &wfx;
-
-  if((hr = pDirectSound->CreateSoundBuffer(&dsbdesc, &dsbSecondary, NULL))
-     != DS_OK) {
-    dsbdesc.dwFlags = DSBCAPS_GETCURRENTPOSITION2;
-    if((hr = pDirectSound->CreateSoundBuffer(&dsbdesc, &dsbSecondary, NULL))
-       != DS_OK) {
-      systemMessage(IDS_CANNOT_CREATESOUNDBUFFER_SEC,
-                    "Cannot CreateSoundBuffer secondary %08x", hr);
-      return false;
-    }
-  }
-
-  dsbSecondary->SetCurrentPosition(0);
-
-  if(!theApp.useOldSync) {
-    hr = dsbSecondary->QueryInterface(IID_IDirectSoundNotify,
-                                      (void **)&dsbNotify);
-    if(!FAILED(hr)) {
-      dsbEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
-      
-      DSBPOSITIONNOTIFY notify[10];
-      
-      for(int i = 0; i < 10; i++) {
-        notify[i].dwOffset = i*soundBufferLen;
-        notify[i].hEventNotify = dsbEvent;
-      }
-      if(FAILED(dsbNotify->SetNotificationPositions(10, notify))) {
-        dsbNotify->Release();
-        dsbNotify = NULL;
-        CloseHandle(dsbEvent);
-        dsbEvent = NULL;
-      }
-    }
-  }
-  
-  hr = dsbPrimary->Play(0,0,DSBPLAY_LOOPING);
-
-  if(hr != DS_OK) {
-    //    errorMessage(myLoadString(IDS_ERROR_SOUND_PLAYPRIM), hr);
-    systemMessage(IDS_CANNOT_PLAY_PRIMARY, "Cannot Play primary %08x", hr);
-    return false;
-  }
-
-  systemSoundOn = true;
-  
-  return true;
+	HRESULT hr;
+	DWORD freq;
+	DSBUFFERDESC dsbdesc;
+	int i;
+
+
+	// Initialize DirectSound
+	if( FAILED( hr = DirectSoundCreate8( &DSDEVID_DefaultPlayback, &pDirectSound, NULL ) ) ) {
+		systemMessage( IDS_CANNOT_CREATE_DIRECTSOUND, _T("Cannot create DirectSound %08x"), hr );
+		pDirectSound = NULL;
+		return false;
+	}
+
+
+	if( FAILED( hr = pDirectSound->SetCooperativeLevel( theApp.m_pMainWnd->GetSafeHwnd(), DSSCL_EXCLUSIVE ) ) ) {
+		systemMessage( IDS_CANNOT_SETCOOPERATIVELEVEL, _T("Cannot SetCooperativeLevel %08x"), hr );
+		return false;
+	}
+
+
+	// Create primary sound buffer
+	ZeroMemory( &dsbdesc, sizeof(DSBUFFERDESC) );
+	dsbdesc.dwSize = sizeof(DSBUFFERDESC);
+	dsbdesc.dwFlags = DSBCAPS_PRIMARYBUFFER;
+	if( theApp.dsoundDisableHardwareAcceleration ) {
+		dsbdesc.dwFlags |= DSBCAPS_LOCSOFTWARE;
+	}
+
+	if( FAILED( hr = pDirectSound->CreateSoundBuffer( &dsbdesc, &dsbPrimary, NULL ) ) ) {
+		systemMessage(IDS_CANNOT_CREATESOUNDBUFFER, _T("Cannot CreateSoundBuffer %08x"), hr);
+		return false;
+	}
+
+	switch(soundQuality)
+	{
+	case 4:
+		freq = 11025;
+		break;
+	case 2:
+		freq = 22050;
+		break;
+	default:
+		soundQuality = 1;
+	case 1:
+		freq = 44100;
+		break;
+	}
+	soundBufferLen = freq*2/30;
+	soundBufferTotalLen = soundBufferLen * 10;
+
+	ZeroMemory( &wfx, sizeof(WAVEFORMATEX) );
+	wfx.wFormatTag = WAVE_FORMAT_PCM;
+	wfx.nChannels = 2;
+	wfx.nSamplesPerSec = freq;
+	wfx.wBitsPerSample = 16;
+	wfx.nBlockAlign = wfx.nChannels * wfx.wBitsPerSample / 8;
+	wfx.nAvgBytesPerSec = wfx.nSamplesPerSec * wfx.nBlockAlign;
+
+	if( FAILED( hr = dsbPrimary->SetFormat( &wfx ) ) ) {
+		systemMessage( IDS_CANNOT_SETFORMAT_PRIMARY, _T("CreateSoundBuffer(primary) failed %08x"), hr );
+		return false;
+	}
+
+
+	// Create secondary sound buffer
+	ZeroMemory( &dsbdesc, sizeof(DSBUFFERDESC) );
+	dsbdesc.dwSize = sizeof(DSBUFFERDESC);
+	dsbdesc.dwFlags = DSBCAPS_GETCURRENTPOSITION2 | DSBCAPS_CTRLPOSITIONNOTIFY | DSBCAPS_GLOBALFOCUS;
+	if( theApp.dsoundDisableHardwareAcceleration ) {
+		dsbdesc.dwFlags |= DSBCAPS_LOCSOFTWARE;
+	}
+	dsbdesc.dwBufferBytes = soundBufferTotalLen;
+	dsbdesc.lpwfxFormat = &wfx;
+
+	if( FAILED( hr = pDirectSound->CreateSoundBuffer( &dsbdesc, &dsbSecondary, NULL ) ) ) {
+		systemMessage( IDS_CANNOT_CREATESOUNDBUFFER, _T("CreateSoundBuffer(secondary) failed %08x"), hr );
+		return false;
+	}
+
+	if( FAILED( hr = dsbSecondary->SetCurrentPosition( 0 ) ) ) {
+		systemMessage( 0, _T("dsbSecondary->SetCurrentPosition failed %08x"), hr );
+		return false;
+	}
+
+
+	if( !theApp.useOldSync ) {
+		if( FAILED( hr = dsbSecondary->QueryInterface( IID_IDirectSoundNotify8, (LPVOID*)&dsbNotify ) ) ) {
+			dsbEvent = CreateEvent( NULL, FALSE, FALSE, NULL );
+			DSBPOSITIONNOTIFY notify[10];		
+			for( i = 0; i < 10; i++ ) {
+				notify[i].dwOffset = i * soundBufferLen;
+				notify[i].hEventNotify = dsbEvent;
+			}
+
+			if( FAILED( dsbNotify->SetNotificationPositions( 10, notify ) ) ) {
+				dsbNotify->Release();
+				dsbNotify = NULL;
+				CloseHandle(dsbEvent);
+				dsbEvent = NULL;
+			}
+		}
+	}
+
+
+	// Play primary buffer
+	if( FAILED( hr = dsbPrimary->Play( 0, 0, DSBPLAY_LOOPING ) ) ) {
+		systemMessage( IDS_CANNOT_PLAY_PRIMARY, _T("Cannot Play primary %08x"), hr );
+		return false;
+	}
+	
+	systemSoundOn = true;
+	
+	return true;
 }
 
+
 void DirectSound::pause()
 {
-  if(dsbSecondary != NULL) {
-    DWORD status = 0;
-    dsbSecondary->GetStatus(&status);
-    
-    if(status & DSBSTATUS_PLAYING) {
-      dsbSecondary->Stop();
-    }
-  }  
+	if( dsbSecondary == NULL ) return;
+	
+	DWORD status;
+
+	dsbSecondary->GetStatus( &status );
+
+	if( status & DSBSTATUS_PLAYING ) dsbSecondary->Stop();
 }
 
+
 void DirectSound::reset()
 {
-  if(dsbSecondary) {
-    dsbSecondary->Stop();
-    dsbSecondary->SetCurrentPosition(0);
-  }  
+	if( dsbSecondary == NULL ) return;
+	
+	dsbSecondary->Stop();
+	
+	dsbSecondary->SetCurrentPosition( 0 );
 }
 
+
 void DirectSound::resume()
 {
-  if(dsbSecondary != NULL) {
-    dsbSecondary->Play(0,0,DSBPLAY_LOOPING);
-  }  
+	if( dsbSecondary == NULL ) return;
+	
+	dsbSecondary->Play( 0, 0, DSBPLAY_LOOPING );
 }
 
+
 void DirectSound::write()
 {
-  int len = soundBufferLen;
-  LPVOID  lpvPtr1; 
-  DWORD   dwBytes1; 
-  LPVOID  lpvPtr2; 
-  DWORD   dwBytes2; 
-
-  if(!pDirectSound)
-    return;
-
-  if(theApp.soundRecording) {
-    if(dsbSecondary) {
-      if(theApp.soundRecorder == NULL) {
-        theApp.soundRecorder = new WavWriter;
-        WAVEFORMATEX format;
-        dsbSecondary->GetFormat(&format, sizeof(format), NULL);
-        if(theApp.soundRecorder->Open(theApp.soundRecordName))
-          theApp.soundRecorder->SetFormat(&format);
-      }
-    }
-      
-    if(theApp.soundRecorder) {
-      theApp.soundRecorder->AddSound((u8 *)soundFinalWave, len);
-    }
-  }
-
-  if(theApp.aviRecording) {
-    if(theApp.aviRecorder) {
-      if(dsbSecondary) {
-        if(!theApp.aviRecorder->IsSoundAdded()) {
-          WAVEFORMATEX format;
-          dsbSecondary->GetFormat(&format, sizeof(format), NULL);
-          theApp.aviRecorder->SetSoundFormat(&format);
-        }
-      }
-      
-      theApp.aviRecorder->AddSound((const char *)soundFinalWave, len);
-    }
-  }
-  
-  HRESULT hr;
-
-  if(!speedup && synchronize && !theApp.throttle) {
-    DWORD status=0;
-    hr = dsbSecondary->GetStatus(&status);
-    if(status && DSBSTATUS_PLAYING) {
-      if(!soundPaused) {      
-        DWORD play;
-        while(true) {
-          dsbSecondary->GetCurrentPosition(&play, NULL);
-
-          if(play < soundNextPosition ||
-             play > soundNextPosition+soundBufferLen) {
-            break;
-          }
-
-          if(dsbEvent) {
-            WaitForSingleObject(dsbEvent, 50);
-          }
-        }
-      }
-    } else {
-      soundPaused = 1;
-    }
-  }
-  // Obtain memory address of write block. This will be in two parts
-  // if the block wraps around.
-  hr = dsbSecondary->Lock(soundNextPosition, soundBufferLen, &lpvPtr1, 
-                          &dwBytes1, &lpvPtr2, &dwBytes2,
-                          0);
-  
-  // If DSERR_BUFFERLOST is returned, restore and retry lock. 
-  if (DSERR_BUFFERLOST == hr) { 
-    dsbSecondary->Restore(); 
-    hr = dsbSecondary->Lock(soundNextPosition, soundBufferLen,&lpvPtr1,
-                            &dwBytes1, &lpvPtr2, &dwBytes2,
-                            0);
-  } 
-
-  soundNextPosition += soundBufferLen;
-  soundNextPosition = soundNextPosition % soundBufferTotalLen;
-  
-  if SUCCEEDED(hr) { 
-    // Write to pointers. 
-    CopyMemory(lpvPtr1, soundFinalWave, dwBytes1); 
-    if (NULL != lpvPtr2) { 
-      CopyMemory(lpvPtr2, soundFinalWave+dwBytes1, dwBytes2); 
-    } 
-    // Release the data back to DirectSound. 
-    hr = dsbSecondary->Unlock(lpvPtr1, dwBytes1, lpvPtr2, 
-                              dwBytes2);
-  }
+	if(!pDirectSound) return;
+
+
+	HRESULT      hr;
+	DWORD        status = 0;
+	DWORD        play = 0;
+	WAVEFORMATEX format;
+	LPVOID       lpvPtr1;
+	DWORD        dwBytes1 = 0;
+	LPVOID       lpvPtr2;
+	DWORD        dwBytes2 = 0;
+
+
+	if( theApp.soundRecording ) {
+		if( dsbSecondary ) {
+			if( theApp.soundRecorder ) {
+				theApp.soundRecorder->AddSound( (u8 *)soundFinalWave, soundBufferLen );
+			} else {
+				theApp.soundRecorder = new WavWriter;
+				dsbSecondary->GetFormat( &format, sizeof(format), NULL );
+				if( theApp.soundRecorder->Open( theApp.soundRecordName ) ) {
+					theApp.soundRecorder->SetFormat( &format );
+				}
+			}
+		}
+	}
+	
+
+	if( theApp.aviRecording ) {
+		if( theApp.aviRecorder ) {
+			if( dsbSecondary ) {
+				if( !theApp.aviRecorder->IsSoundAdded() ) {
+					dsbSecondary->GetFormat( &format, sizeof(format), NULL );
+					theApp.aviRecorder->SetSoundFormat( &format );
+				}
+			}
+			theApp.aviRecorder->AddSound( (const char *)soundFinalWave, soundBufferLen );
+		}
+	}
+	
+	
+	if( !speedup && synchronize && !theApp.throttle ) {
+		hr = dsbSecondary->GetStatus(&status);
+		if( status & DSBSTATUS_PLAYING ) {
+			if( !soundPaused ) {      
+				while( true ) {
+					dsbSecondary->GetCurrentPosition(&play, NULL);
+					if( ( play < soundNextPosition ) || ( play > (soundNextPosition + soundBufferLen) ) ) {
+						break;
+					}
+					if( dsbEvent ) {
+						WaitForSingleObject(dsbEvent, 50);
+					}
+				}
+			}
+		} else {
+			soundPaused = 1;
+		}
+	}
+	
+
+	// Obtain memory address of write block.
+	// This will be in two parts if the block wraps around.
+	if( DSERR_BUFFERLOST == ( hr = dsbSecondary->Lock(
+		soundNextPosition,
+		soundBufferLen,
+		&lpvPtr1,
+		&dwBytes1,
+		&lpvPtr2,
+		&dwBytes2,
+		0 ) ) ) {
+			// If DSERR_BUFFERLOST is returned, restore and retry lock.
+			dsbSecondary->Restore();
+			hr = dsbSecondary->Lock(
+				soundNextPosition,
+				soundBufferLen,
+				&lpvPtr1,
+				&dwBytes1,
+				&lpvPtr2,
+				&dwBytes2,
+				0 );
+	}
+	
+	soundNextPosition += soundBufferLen;
+	soundNextPosition = soundNextPosition % soundBufferTotalLen;
+
+	if( SUCCEEDED( hr ) ) {
+		// Write to pointers.
+		CopyMemory( lpvPtr1, soundFinalWave, dwBytes1 );
+		if ( lpvPtr2 ) {
+			CopyMemory( lpvPtr2, soundFinalWave + dwBytes1, dwBytes2 );
+		}
+		
+		// Release the data back to DirectSound.
+		hr = dsbSecondary->Unlock( lpvPtr1, dwBytes1, lpvPtr2, dwBytes2 );
+	} else {
+		systemMessage( 0, _T("dsbSecondary->Lock() failed: %08x"), hr );
+		return;
+	}
 }
 
+
 ISound *newDirectSound()
 {
-  return new DirectSound();
+	return new DirectSound();
 }
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/Directories.cpp ./src/win32/Directories.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/Directories.cpp	2004-05-13 23:27:43 +0900
+++ ./src/win32/Directories.cpp	2006-08-04 20:24:24 +0900
@@ -26,6 +26,7 @@
 #include "WinResUtil.h"
 
 #include <shlobj.h>
+#include <shlwapi.h>
 
 #ifdef _DEBUG
 #define new DEBUG_NEW
@@ -54,27 +55,21 @@
 Directories::Directories(CWnd* pParent /*=NULL*/)
   : CDialog(Directories::IDD, pParent)
 {
-  //{{AFX_DATA_INIT(Directories)
-  // NOTE: the ClassWizard will add member initialization here
-  //}}AFX_DATA_INIT
 }
 
 
 void Directories::DoDataExchange(CDataExchange* pDX)
 {
   CDialog::DoDataExchange(pDX);
-  //{{AFX_DATA_MAP(Directories)
   DDX_Control(pDX, IDC_SAVE_PATH, m_savePath);
   DDX_Control(pDX, IDC_ROM_PATH, m_romPath);
   DDX_Control(pDX, IDC_GBROM_PATH, m_gbromPath);
   DDX_Control(pDX, IDC_CAPTURE_PATH, m_capturePath);
   DDX_Control(pDX, IDC_BATTERY_PATH, m_batteryPath);
-  //}}AFX_DATA_MAP
 }
 
 
 BEGIN_MESSAGE_MAP(Directories, CDialog)
-  //{{AFX_MSG_MAP(Directories)
   ON_BN_CLICKED(IDC_BATTERY_DIR, OnBatteryDir)
   ON_BN_CLICKED(IDC_BATTERY_DIR_RESET, OnBatteryDirReset)
   ON_BN_CLICKED(IDC_CAPTURE_DIR, OnCaptureDir)
@@ -85,8 +80,7 @@
   ON_BN_CLICKED(IDC_ROM_DIR_RESET, OnRomDirReset)
   ON_BN_CLICKED(IDC_SAVE_DIR, OnSaveDir)
   ON_BN_CLICKED(IDC_SAVE_DIR_RESET, OnSaveDirReset)
-  //}}AFX_MSG_MAP
-  END_MESSAGE_MAP()
+END_MESSAGE_MAP()
 
   /////////////////////////////////////////////////////////////////////////////
 // Directories message handlers
@@ -206,23 +200,76 @@
 
 void Directories::OnOK() 
 {
-  CString buffer;
-  m_romPath.GetWindowText(buffer);
-  if(!buffer.IsEmpty())
-    regSetStringValue("romdir", buffer);
-  m_gbromPath.GetWindowText(buffer);
-  if(!buffer.IsEmpty())
-    regSetStringValue("gbromdir", buffer);      
-  m_batteryPath.GetWindowText(buffer);
-  if(!buffer.IsEmpty())
-    regSetStringValue("batteryDir", buffer);
-  m_savePath.GetWindowText(buffer);
-  if(!buffer.IsEmpty())
-    regSetStringValue("saveDir", buffer);
-  m_capturePath.GetWindowText(buffer);
-  if(!buffer.IsEmpty())
-    regSetStringValue("captureDir", buffer);      
-  EndDialog(TRUE);
+	char baseDir[MAX_PATH+1];
+	char temp[MAX_PATH+1];
+	GetModuleFileName( NULL, baseDir, MAX_PATH );
+	baseDir[MAX_PATH] = '\0'; // for security reasons
+	PathRemoveFileSpec( baseDir ); // removes the trailing file name and backslash
+
+
+	CString buffer;
+
+	m_romPath.GetWindowText(buffer);
+	if( !buffer.IsEmpty() )
+		regSetStringValue( "romdir", buffer );
+	if( buffer[0] == '.' ) {
+		strcpy( temp, baseDir );
+		strcat( temp, "\\" );
+		strcat( temp, buffer );
+		buffer = temp;
+	}
+	if( !directoryDoesExist( buffer ) )
+		SHCreateDirectoryEx( NULL, buffer, NULL );
+
+	m_gbromPath.GetWindowText(buffer);
+	if( !buffer.IsEmpty() )
+		regSetStringValue( "gbromdir", buffer );      
+	if( buffer[0] == '.' ) {
+		strcpy( temp, baseDir );
+		strcat( temp, "\\" );
+		strcat( temp, buffer );
+		buffer = temp;
+	}
+	if( !directoryDoesExist( buffer ) )
+		SHCreateDirectoryEx( NULL, buffer, NULL );
+
+	m_batteryPath.GetWindowText(buffer);
+	if( !buffer.IsEmpty() )
+		regSetStringValue( "batteryDir", buffer );
+	if( buffer[0] == '.' ) {
+		strcpy( temp, baseDir );
+		strcat( temp, "\\" );
+		strcat( temp, buffer );
+		buffer = temp;
+	}
+	if( !directoryDoesExist( buffer ) )
+		SHCreateDirectoryEx( NULL, buffer, NULL );
+
+	m_savePath.GetWindowText(buffer);
+	if( !buffer.IsEmpty() )
+		regSetStringValue( "saveDir", buffer );
+	if( buffer[0] == '.' ) {
+		strcpy( temp, baseDir );
+		strcat( temp, "\\" );
+		strcat( temp, buffer );
+		buffer = temp;
+	}
+	if( !directoryDoesExist( buffer ) )
+		SHCreateDirectoryEx( NULL, buffer, NULL );
+
+	m_capturePath.GetWindowText(buffer);
+	if( !buffer.IsEmpty() )
+		regSetStringValue( "captureDir", buffer );
+	if( buffer[0] == '.' ) {
+		strcpy( temp, baseDir );
+		strcat( temp, "\\" );
+		strcat( temp, buffer );
+		buffer = temp;
+	}
+	if( !directoryDoesExist( buffer ) )
+		SHCreateDirectoryEx( NULL, buffer, NULL );
+
+	EndDialog(TRUE);
 }
 
 CString Directories::browseForDir(CString title)
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/Directories.h ./src/win32/Directories.h
--- ../VisualBoyAdvance-1.7.2/src/win32/Directories.h	2004-05-13 22:46:19 +0900
+++ ./src/win32/Directories.h	2006-08-04 20:24:24 +0900
@@ -75,7 +75,24 @@
   virtual void OnOK();
   //}}AFX_MSG
   DECLARE_MESSAGE_MAP()
-    };
+private:
+
+	bool directoryDoesExist(const char *directory)
+	{ // returns true if the directory does exist
+		HANDLE hDir;
+		hDir = CreateFile(
+			directory,
+			GENERIC_READ,
+			FILE_SHARE_READ|FILE_SHARE_WRITE|FILE_SHARE_DELETE,
+			NULL,
+			OPEN_EXISTING,
+			FILE_FLAG_BACKUP_SEMANTICS,
+			NULL );
+		bool retval = (hDir == INVALID_HANDLE_VALUE) ? false : true;
+		CloseHandle( hDir );
+		return retval;
+	}
+};
 
     //{{AFX_INSERT_LOCATION}}
     // Microsoft Visual C++ will insert additional declarations immediately before the previous line.
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/Disassemble.cpp ./src/win32/Disassemble.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/Disassemble.cpp	2004-05-13 23:27:30 +0900
+++ ./src/win32/Disassemble.cpp	2005-06-25 15:23:31 +0900
@@ -1,6 +1,6 @@
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -118,6 +118,7 @@
 void Disassemble::OnArm() 
 {
   mode = 1;
+  address&=0xfffffffC;
   refresh();
 }
 
@@ -133,21 +134,30 @@
   CString buffer;
   m_address.GetWindowText(buffer);
   sscanf(buffer, "%x", &address);
+  if (mode==1)
+      address&=0xfffffffc;
+  else if (mode==2)
+      address&=0xfffffffe;
   refresh();
 }
 
 void Disassemble::OnGopc() 
 {
+  if(rom != NULL)
+  {
   if(armState)
     address = armNextPC - 16;
   else
     address = armNextPC - 8;
 
   refresh();
+  }
 }
 
 void Disassemble::OnNext() 
 {
+  if(rom != NULL)
+  {
   CPULoop(1);
   if(armState) {
     u32 total = address+count*4;
@@ -163,6 +173,7 @@
     }
   }
   refresh();
+  }
 }
 
 void Disassemble::OnRefresh() 
@@ -173,6 +184,7 @@
 void Disassemble::OnThumb() 
 {
   mode = 2;
+  address&=0xfffffffe;
   refresh();
 }
 
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/Display.h ./src/win32/Display.h
--- ../VisualBoyAdvance-1.7.2/src/win32/Display.h	2004-05-13 22:45:59 +0900
+++ ./src/win32/Display.h	2006-08-06 02:29:31 +0900
@@ -17,6 +17,8 @@
 // along with this program; if not, write to the Free Software Foundation,
 // Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 
+#pragma once
+
 enum DISPLAY_TYPE {
   GDI = 0,
   DIRECT_DRAW = 1,
@@ -32,13 +34,15 @@
   virtual bool initialize() = 0;
   virtual void cleanup() = 0;
   virtual void render() = 0;
-  virtual void checkFullScreen() { };
-  virtual void renderMenu() { };
-  virtual void clear()=0;
+  virtual void checkFullScreen() {};
+  virtual void renderMenu() {};
+  virtual void clear() = 0;
   virtual bool changeRenderSize(int w, int h) { return true; };
   virtual void resize(int w, int h) {};
-  virtual void setOption(const char *option, int value) = 0;
+  virtual void setOption(const char *option, int value) {};
   virtual DISPLAY_TYPE getType() = 0;
   virtual bool isSkinSupported() { return false; }
   virtual int selectFullScreenMode(GUID **) = 0;
 };
+
+void copyImage( void *source, void *destination, unsigned int width, unsigned int height, unsigned int destinationPitch, unsigned int colorDepth );
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/FileDlg.cpp ./src/win32/FileDlg.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/FileDlg.cpp	2004-05-13 23:27:04 +0900
+++ ./src/win32/FileDlg.cpp	2006-05-27 23:47:33 +0900
@@ -1,6 +1,6 @@
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -18,7 +18,7 @@
 
 // FileDlg.cpp: implementation of the FileDlg class.
 //
-//////////////////////////////////////////////////////////////////////
+
 #include "stdafx.h"
 #include <commdlg.h>
 #include <dlgs.h>
@@ -159,20 +159,23 @@
 
   ASSERT(typeControl != NULL);
 
-  int sel = ::SendMessage(typeControl, CB_GETCURSEL, 0, 0);
+  LRESULT sel = ::SendMessage(typeControl, CB_GETCURSEL, 0, 0);
 
   ASSERT(sel != -1);
   
   LPCTSTR typeName = extensions[sel];
   
   if(filename.GetLength() == 0) {
-    filename.Format("*%s", typeName);
+    if(strlen(typeName) != 0)
+      filename.Format("*%s", typeName);
   } else {
-    int index = filename.Find('.');
-    if (index == -1) {
-      filename = filename + typeName;
-    } else {
-      filename = filename.Left(index) + typeName;
+    if(strlen(typeName) != 0) {
+      int index = filename.Find('.');
+      if (index == -1) {
+        filename = filename + typeName;
+      } else {
+        filename = filename.Left(index) + typeName;
+      }
     }
   }
   SetWindowText(fileNameControl, filename);
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/GBACheats.cpp ./src/win32/GBACheats.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/GBACheats.cpp	2004-05-13 23:26:53 +0900
+++ ./src/win32/GBACheats.cpp	2006-05-27 23:47:33 +0900
@@ -684,7 +684,7 @@
     break;
   }
   
-  cheatsAdd(code, buffer,address, value,-1, sizeType);
+  cheatsAdd(code, buffer, address ,address, value,-1, sizeType);
   return true;
 }
 /////////////////////////////////////////////////////////////////////////////
@@ -765,16 +765,16 @@
   if(mark != -1) {
     LVITEM item;
     for(int i = 0; i < count; i++) {
-      memset(&item,0, sizeof(item));
+      memset(&item, 0, sizeof(item));
       item.mask = LVIF_PARAM|LVIF_STATE;
       item.stateMask = LVIS_SELECTED;
       item.iItem = i;
       if(m_list.GetItem(&item)) {
         if(item.state & LVIS_SELECTED) {
           if(cheatsList[item.lParam].enabled)
-            cheatsDisable(item.lParam);
+            cheatsDisable((int)(item.lParam & 0xFFFFFFFF));
           else
-            cheatsEnable(item.lParam);
+            cheatsEnable((int)(item.lParam & 0xFFFFFFFF));
         }
       }
     }
@@ -796,7 +796,7 @@
       item.stateMask = LVIS_SELECTED;
       if(m_list.GetItem(&item)) {
         if(item.state & LVIS_SELECTED) {
-          cheatsDelete(item.lParam, restoreValues);
+          cheatsDelete((int)(item.lParam & 0xFFFFFFFF), restoreValues);
         }
       }
     }
@@ -838,9 +838,9 @@
       if(((l->uOldState & LVIS_STATEIMAGEMASK)>>12) !=
          (((l->uNewState & LVIS_STATEIMAGEMASK)>>12))) {
         if(m_list.GetCheck(l->iItem))
-          cheatsEnable(l->lParam);
+          cheatsEnable((int)(l->lParam & 0xFFFFFFFF));
         else
-          cheatsDisable(l->lParam);
+          cheatsDisable((int)(l->lParam & 0xFFFFFFFF));
         refresh();
       }
     }
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/GBACheats.h ./src/win32/GBACheats.h
--- ../VisualBoyAdvance-1.7.2/src/win32/GBACheats.h	2004-05-13 22:45:27 +0900
+++ ./src/win32/GBACheats.h	2006-05-27 23:47:33 +0900
@@ -20,7 +20,7 @@
 #if !defined(AFX_GBACHEATS_H__FC31D47D_52C8_42B2_95C7_7C3FD09316A4__INCLUDED_)
 #define AFX_GBACHEATS_H__FC31D47D_52C8_42B2_95C7_7C3FD09316A4__INCLUDED_
 
-#include "..\System.h"  // Added by ClassView
+#include "../System.h"  // Added by ClassView
 #if _MSC_VER > 1000
 #pragma once
 #endif // _MSC_VER > 1000
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/GBCheatsDlg.cpp ./src/win32/GBCheatsDlg.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/GBCheatsDlg.cpp	2004-05-13 23:26:36 +0900
+++ ./src/win32/GBCheatsDlg.cpp	2006-06-07 06:04:21 +0900
@@ -637,7 +637,7 @@
 
   m_desc.GetWindowText(buffer);
 
-  int bank = (address >> 16);
+  LONG_PTR bank = (address >> 16);
   address &= 0xFFFF;
 
   if(address >= 0xd000)
@@ -689,9 +689,7 @@
   buffer.Format("%02x:%08x", (address>>16), address&0xFFFF);
   m_address.SetWindowText(buffer);
   m_address.EnableWindow(FALSE);
-  ::SetWindowLong(m_address,
-                  GWL_USERDATA,
-                  address);
+  ::SetWindowLongPtr( m_address.GetSafeHwnd(), GWLP_USERDATA, address);
   
   numberType = regQueryDwordValue("gbCheatsNumberType", 2);
   if(numberType < 0 || numberType > 2)
@@ -826,9 +824,9 @@
     item.iItem = mark;
     if(m_list.GetItem(&item)) {
       if(gbCheatList[item.lParam].enabled)
-        gbCheatDisable(item.lParam);
+        gbCheatDisable((int)item.lParam);
       else
-        gbCheatEnable(item.lParam);
+        gbCheatEnable((int)item.lParam);
       refresh();
     }       
   }
@@ -844,7 +842,7 @@
     item.mask = LVIF_PARAM;
     item.iItem = mark;
     if(m_list.GetItem(&item)) {
-      gbCheatRemove(item.lParam);
+      gbCheatRemove((int)item.lParam);
       refresh();
     }       
   }
@@ -872,9 +870,9 @@
       if(((l->uOldState & LVIS_STATEIMAGEMASK)>>12) !=
          (((l->uNewState & LVIS_STATEIMAGEMASK)>>12))) {
         if(m_list.GetCheck(l->iItem))
-          gbCheatEnable(l->lParam);
+          gbCheatEnable((int)l->lParam);
         else
-          gbCheatDisable(l->lParam);
+          gbCheatDisable((int)l->lParam);
         refresh();
       }
     }
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/GBCheatsDlg.h ./src/win32/GBCheatsDlg.h
--- ../VisualBoyAdvance-1.7.2/src/win32/GBCheatsDlg.h	2004-05-13 22:45:12 +0900
+++ ./src/win32/GBCheatsDlg.h	2006-06-07 06:04:21 +0900
@@ -121,7 +121,7 @@
 
   // Implementation
  protected:
-  u32 address;
+  LONG_PTR address;
 
   // Generated message map functions
   //{{AFX_MSG(AddGBCheat)
